---------- CREATE USER_DOCUMENT TABLE ----------
CREATE TABLE "VAP"."USER_DOCUMENT" 
	(	"DOCUMENT_ID" NUMBER NOT NULL, 
		"USER_ID" VARCHAR2(255 BYTE) NOT NULL, 
		"CREATION_DATE" TIMESTAMP (6) NOT NULL, 
		"TITLE" VARCHAR2(255 BYTE) NOT NULL, 
		"CONTENT" BLOB,
		"STATUS" VARCHAR2(30 BYTE) NOT NULL,
		"FORMAT" VARCHAR2(30 BYTE) NOT NULL
	);
CREATE UNIQUE INDEX "USER_DOCUMENTS_PK" ON "VAP"."USER_DOCUMENT" ("DOCUMENT_ID");
CREATE OR REPLACE SYNONYM VAP_APP.USER_DOCUMENT FOR VAP.USER_DOCUMENT;
GRANT SELECT ON "VAP"."USER_DOCUMENT" TO VAP_USER;
GRANT SELECT ON "VAP"."USER_DOCUMENT" TO VAP_READ;
GRANT INSERT ON "VAP"."USER_DOCUMENT" TO VAP_USER;
GRANT UPDATE ON "VAP"."USER_DOCUMENT" TO VAP_USER;
GRANT DELETE ON "VAP"."USER_DOCUMENT" TO VAP_USER;

----------- ADD NEW DESCRIPTIONS TO DESCRIPTOR TABLE -----------
INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'setDefaultFacilityButton', 'Set Default Facility');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveAll', 'Move all organizations to the right box.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveSelectedRight', 'Move the selected organizations to the right box.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveSelectedLeft', 'Move the selected organizations to the left box.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceClear', 'Clear all selections');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryAuthorizations', 'This column displays the total number of eHealth Exchange Authorizations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRevocations', 'This column displays the total number of eHealth Exchange Authorization Revocations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRestrictions', 'This column displays the total number of eHealth Exchange Restriction Authorizations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRestrictionRevocations', 'This column displays the total number of eHealth Exchange Restriction Revocations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummarySSAAuthorizations', 'This column displays the total number of Social Security Administration Authorizations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummarySSARevocations', 'This column displays the total number of Social Security Administration Authorization Revocations for the given filtering criteria.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsReportColumn', 'This column displays the title of the scheduled report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsFormatColumn', 'This column displays the format of the scheduled report - Excel or CSV.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsDateColumn', 'This column displays the date and time the report was scheduled to be exported.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsStatusColumn', 'This column indicates whether the scheduled export is still pending or ready to be downloaded.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsDownloadColumn', 'This column contains action buttons to download the exports that have been completed.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportRemoteOrganizationColumn', 'This column displays the name of the partner organization that sent the clinical document.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportUserColumn', 'This column displays the name of the user that initiated document retrieval.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportCountColumn', 'This column displays the count of documents received by given user from given partner organization.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportStartMonthYearField', 'This field allow you to select the month and year to filter report results by.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresDirectAddress', 'This column displayes the Direct address used to which the VA disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportFacilityColumn', 'This column displays the VA facility that sent the disclosed record.');

----------- ADD NEW COLUMNS TO ANNOUNCEMENT TABLE -----------
ALTER TABLE ANNOUNCEMENT
ADD FIRST_NAME VARCHAR2(100 CHAR) NULL;

ALTER TABLE ANNOUNCEMENT
ADD LAST_NAME VARCHAR2(100 CHAR) NULL;

ALTER TABLE ANNOUNCEMENT
ADD SSN VARCHAR2(20 CHAR) NULL;

COMMIT;