<%--
    Document   : scheduledExports
    Created on : Sep 8, 2016, 12:08:31 PM
    Author     : Zachary Tubb
--%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<%
    String userName = request.getRemoteUser();
%>

<f:mainTemplate headerText="Scheduled Exports" userName="<%=userName%>">
    <script language="JavaScript">
        $(document).ready(function(){
            $.fn.dataTable.ext.errMode = 'none';

            var reportTable = $('#reportTable').DataTable( {
                searching: false,
                processing: true,
                serverSide: true,
                order: [[2, 'desc']],
                ajax: "ScheduledExports.do_sec?getUserExports=true",
                columnDefs: [
                    {orderable: false, targets: 4},
                    {className: "dt-head-center", targets: [0,1,2,3]},
                    {className: "dt-head-center dt-body-center", targets: 4}
                ],
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25
            });
            reportTable.on('draw', function () {
                addAriaToDataTable('reportTable', reportTable);
            });
            $('#refreshButton').on('click', function() {
                $('#reportTable').DataTable().ajax.reload();
            });
            
            // DataTables overrides
            setProcessingForDataTable('reportTable');

            reportTable.on('draw', function () {
                addAriaToDataTable('reportTable', reportTable);
            });
        });
    </script>
    <div class="well">
        Excel and CSV exports for reports will appear here for download once the export generation has been completed.
    </div>
    <div id="divReportContent">
        <hr />
        <button class="btn pull-right" id="refreshButton" title="Refresh">Refresh <span class="fa fa-refresh" aria-hidden="true"></span></button>
        <table id="reportTable" class="display" width="100%" cellspacing="0" role="presentation">
            <thead>
                <tr role="row">
                    <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['scheduledExportsReportColumn']}" />">Report</span></th>
                    <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['scheduledExportsFormatColumn']}" />">Format</span></th>
                    <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['scheduledExportsDateColumn']}" />">Date Generated (CT)</span></th>
                    <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['scheduledExportsStatusColumn']}" />">Status</span></th>
                    <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['scheduledExportsDownloadColumn']}" />" data-tooltip-position="left">Download</span></th>
                </tr>
            </thead>
        </table>
    </div>
</f:mainTemplate>